#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#define MAX_SIZE_CHUNK 0x58

struct string{
	int maximumNumbers;
	int used;
	char **stringDescription;
};

void setup(){
	setvbuf(stdin, NULL, _IONBF, 0);
    setvbuf(stdout, NULL, _IONBF, 0);
	setvbuf(stderr, NULL, _IONBF, 0);
}

int main(){
	setup();
	int created[14];
	for (int i = 0; i < 15; i++)
		created[i] = 1;

	struct string myStrings;
	myStrings.maximumNumbers = 15;
	myStrings.used = 0;
	myStrings.stringDescription = (char **)malloc(myStrings.maximumNumbers * sizeof(char *));
	for (int i = 0; i < myStrings.maximumNumbers; ++i)
		myStrings.stringDescription[i] = NULL;

	while (1 == 1){
		char option[MAX_SIZE_CHUNK + 8]; // "CREATE " is 7 extra bytes.
		read(0, option, MAX_SIZE_CHUNK + 7);
		if (strncmp(option, "CREATE ", 7) == 0) {
            if (myStrings.used < myStrings.maximumNumbers) {
            	int len = 0;
            	while (option[len] != '\n' && len < MAX_SIZE_CHUNK + 7) {
            		len++;
            	}
            	len = len - 7;
            	memcpy(option, option + 7, len);
            	myStrings.stringDescription[myStrings.used] = (char *)malloc(len * sizeof(char));
            	memcpy(myStrings.stringDescription[myStrings.used], option, len);
            	created[myStrings.used]--;
            	myStrings.used++;
            	printf("Created string.\n");
            }
            else {
            	printf("Maximum number of strings created.\n");
            	exit(0);
            }
        } else if (strncmp(option, "DELETE ", 7) == 0) {
            strcpy(option, option + 7);
            int number = 0;
            number = atoi(option);
            if (number >= 15 || option[0] < '0' || option[0] > '9') {
            	printf("Not a valid number.\n");
            	exit(0);
            }
            if (created[number] != 0) {
            	printf("Can't delete something that doesn't exist.\n");
            	exit(0);
            }
            free(myStrings.stringDescription[number]);
            printf("Deleted %d\n", number);
        } else if (strncmp(option, "PRINT ", 6) == 0) {
        	strcpy(option, option + 6);
            int number = 0;
            number = atoi(option);
            if (number >= 15 || option[0] < '0' || option[0] > '9') {
            	printf("Not a valid number.\n");
            	exit(0);
            }
            if (created[number] != 0) {
            	printf("Can't print something that doesn't exist.\n");
            	exit(0);
            }
            printf("String at index %d is: %s\n", number, myStrings.stringDescription[number]);

        } else if (strncmp(option, "EXIT", 4) == 0) {
            printf("Exiting...\n");
            exit(0);

        } else if (strncmp(option, "ENCODE ", 7) == 0) {
        	char buf[MAX_SIZE_CHUNK];
        	strcpy(option, option + 7);
            int number = 0;
            number = atoi(option);
            if (number >= 15 || option[0] < '0' || option[0] > '9') {
            	printf("Not a valid number.\n");
            	exit(0);
            }
            if (created[number] != 0) {
            	printf("Can't encode something that doesn't exist.\n");
            	exit(0);
            }
            strncpy(buf, myStrings.stringDescription[number], strlen(myStrings.stringDescription[number]));
            for (int i = 0; buf[i] != '\0'; ++i)
        		buf[i] += 3;

            printf("Encoded your string!\n%s\n", buf);


        } else {
            printf("Invalid option\n");
        }

	}

	return 0;
}